; Translations Datalog Rules to RA equations
; version1.2.0 
; Fri 02 Apr 2004 11:04:52 AM MSD
;
;
;
; Exported:
 
;
; dtlog->ra
; rule->ra-expr
; rewrite-rule
; right-part-expr
; process-embed-preds
;
; TO-DO:
; 1) optimizations: in right-part-expr 
;   evaluating embed-pred as fast as possible 
; 
; 
;==============================================================================
; Procedures

; rewrite-rule :: rule -> rewritten-rule
; rewritten-rule is a rule, where
; all db-predicates are the first, assign expressions are the second and
; logic predicates are the last
(define (rewrite-rule rule)
  (append (filter atom? rule) 
    (filter assign-expr? rule) (filter logic-pred? rule)))

(define (process-ag-expr temp-terms %temp ag-expr db db-names)
;  (cout "process-ag-expr: " ag-expr nl)
  (let* ((rbody (fifth ag-expr)) 
         (terms (flat-rule-terms rbody))
	 (vars (filter var? terms))
	 (ag-var (fourth ag-expr))
	 (ag-index (list-index (lambda (x) (equal? x ag-var)) vars)))
    (if (not ag-index)
           (error "Semantic error"  "Aggregate variable must be exits in aggregate predicate list " rbody))    
;    (cout "temp-terms = " temp-terms " vars = " vars nl)
    (receive (vars inds)
	 (fold (lambda (v lst)
	         (let ((ind (list-index (lambda(term) (eq? term v)) temp-terms)))
		   (if ind (receive (vars inds) lst 
;		             (cout "1 " vars " " inds nl)
		             (values (cons v vars) (cons ind inds))) lst))) 
    	       (values '() '()) vars)
;      (cout "1 " vars " " inds nl)
      (let* ((aggr-f-tag (sixth ag-expr))
             (aggr-f (cond ((eq? aggr-f-tag sum-tag)
                       (lambda(%res)
                         (fold (lambda(elem res) 
			      (+ (value->number (vector-ref elem ag-index)) res)) 
			     0 %res)))
			    ((eq? aggr-f-tag max-tag) 
		        (lambda(%res)
                         (fold (lambda(elem res) 
			      (let ((v (value->number (vector-ref elem ag-index))))
			        (if (> v res) v res))) -1 %res)))))
    	     (expr-f 
              (lambda (elem)
	        (let* ((subst (map (lambda(v i) (list v (vector-ref elem i))) vars inds))
		       (bind-rbody (apply-rule-subst rbody subst))
		       (query (right-part-expr bind-rbody #f)))
		  (aggr-f (query db db-names))))))
      (extend %temp expr-f)))))

; process-eval-exprs :: temp-terms -> %temp -> corrs -> eval-exprs
; %temp - is a temporary result after all select and join, but not project
; corrs  is or list of indexes of final result's projection 
;           or #f - then  projection isn't performed
; temp-terms is a list of terms are in %temp (header)
; eval-exprs is a list of parsed evaluation expressions
; it guess assign expression are before logic-expr (otherwise conficts can be possible)
(define (process-eval-exprs temp-terms %temp corrs eval-exprs db db-names)
;  (cout "process-eval-exprs. " eval-exprs " %temp = " %temp nl)
  (let rpt ((temp-terms temp-terms) (%temp %temp) (eval-exprs eval-exprs))
  (if (null? eval-exprs)
    (if corrs (projection %temp corrs) %temp)
    (let ((eval-expr (car eval-exprs)))
;      (cout "eval-expr " eval-expr nl)
      (if (assign-ag-expr? eval-expr) 
        (rpt (append temp-terms (list (third eval-expr)))
	        (process-ag-expr temp-terms %temp eval-expr db db-names) 
		(cdr eval-exprs))
        (let* ((vars (car eval-expr))
;	   (a1 (cout "2 " vars nl))
 	   (indexes (map (lambda (v) (list-index (lambda(term) (eq? term v)) temp-terms))
	                    vars))
;	   (a (cout "1 " indexes nl))
           (all-binded? (fold (lambda (x y) (and x y)) #t indexes))
	   (expr-f (lambda (elem)
	            ((cadr eval-expr) ; apply function to vars and vals
		     vars
		     (map (lambda (index) (vector-ref elem index)) indexes)))))
;      (cout "indexes: " indexes nl)
      (if (not all-binded?)
           (error "Semantic error"  "Incorrect using expressions, you are must to bind all variable!" "")
          (if (assign-expr? eval-expr)
              (rpt (append temp-terms (list (third eval-expr)))
	        (extend %temp expr-f) (cdr eval-exprs))
	      (rpt temp-terms   
  	        (select %temp expr-f) (cdr eval-exprs)) ))))))))

; right-part-expr :: rbody -> corrs -> lambda
; function is similar to qsqr.scm.open-query
; but it returns lambda of 2 parameters - db (database) and
; db-names. db is a list of predicate's values with names db-names.
; db-names is a list too.
; rbody is a body of rule and corrs is a list of indexes of final projection
(define (right-part-expr rbody corrs)
; (cout "right-part-expr. rbody = " rbody nl)
 (lambda (db db-names)
; (cout "db = " db nl " db-names = " db-names nl)
 (let rpt ((rule-unproc rbody) (rule-proc '()) (%temp '()) (embed-preds '()))
;    (cout "rpt:" nl rule-unproc "  " rule-proc nl %temp nl)	    
    (if (null? rule-unproc) 
        (process-eval-exprs (flat-rule-terms rule-proc) %temp corrs embed-preds db db-names)
        (let ((sub-aim (car rule-unproc)))
	  (cond ((eval-expr? sub-aim) 
	    (rpt (cdr rule-unproc) rule-proc %temp (append embed-preds (list sub-aim))))
	   ((atom? sub-aim)
	     (let* ((op (op-ra sub-aim rule-proc))
	       (pred (car sub-aim))
	       (db-pred? (list-index (lambda (x) (eq? x pred)) db-names))
	       (db-ind (if db-pred? db-pred?
		                   (list-index (lambda (x) (eq? (car x) pred)) internal-preds)))
               (%pred (if db-pred? 
	                 (list-ref db db-ind)
	                 ((cadr (list-ref internal-preds db-ind)) ; <- this is a function
			    (const-bind sub-aim rule-proc %temp))))
	       (%res (op %temp %pred)))
;        		(cout "%pred="  %pred nl "%temp="%temp nl)
;			(cout "res:" %res nl)
 	 (if (eq-set? %res '())
	     '()
             (rpt (cdr rule-unproc) (append rule-proc (list sub-aim)) %res embed-preds)))))))
)))
;(cout "Test " nl 
;  ((right-part-expr '((p X Z) (p Z Y)) '(0 3)) '(() (#(1 2) #(2 4))) '(a p)) nl)
; -> '(#(1 4))
;(cout "Test (not precisely tested the function in lambda) " nl 
;  ((right-part-expr `((p X Y) ((X) . ,(lambda (x y) (> (car y) 2)))) '(0 1)) '((#(1 2) #(3 4))) '(p)) nl)
; -> '(#(3 4))  


; rule->ra-expr :: rule -> lambda
; translate a rule to lambda perform corresponding ra-expr (see right-part-expr)
(define (rule->ra-expr rule)
 (define (two-eq-terms terms)
;   (cout "2-eq: " terms nl)
   (let loop ((unproc terms) (i 0))  
       (if (null? unproc)
           (values #f #f #f)
  	   (let* ((term-i (car unproc))
	          (j (list-index (lambda (x) (equal? x term-i)) (cdr unproc))))
	     (if j (values term-i i (+ j (+ i 1))) 
	         (loop (cdr unproc) (+ i 1)))))))
 (define (t rule)
;   (cout "t: " rule nl)
   (let* ((rhead (car rule))
          (rbody (cdr rule))
 	  (const-i (find const? rhead)))
  (if const-i
    (let* ((x (newvar-in-rule rule))
            (subst (list (list const-i x)))) 
        (t (cons 
	     (replace1-atom-subst rhead subst) 
	     (append rbody (list (list eq-name x const-i))))))
;elseif
  (receive (var-i i j) (two-eq-terms (cdr rhead))
  (if var-i 
    (let* ((x (newvar-in-rule rule))
            (subst (list (list var-i x))))
        (t (cons 
	     (replace1-atom-subst rhead subst) 
	     (append rbody (list (list eq-name x var-i))))))
 ;else
 (let ((corrs (corr-list rule)))
;     (cout "corrs: " corrs nl)
     (if (not (fold (lambda (x y) (and x y)) #t corrs)) 
       (error "Semantic error, safety condition" "not all variables at rule's head are bounded" rule))
     ;(cout "else " rule nl)
      (right-part-expr (cdr rule) corrs)))))))
 (t (rewrite-rule rule)))

;(cout (rule->ra-expr '((p "b" X X Z) (s X Y) (r Y "a" Z))) nl)

; dtlog->ra :: rules -> list of lambda
; translation Datalog rules to RA+
; returns list of lambda. Each lambda is a relational equaltion
(define (dtlog->ra rules)
 (define (divide-to-one-equation rules)
    (if (null? rules) '()
     (receive (group-r other-r) 
       (partition (lambda (rule) (equal? (caaar rules) (caar rule))) rules)
       (cons group-r (divide-to-one-equation other-r)))))
 (map 
   (lambda (group-r) 
     (lambda (db db-names) 
       (fold (lambda (x res) (union (x db db-names) res))
         empty-pred (map rule->ra-expr group-r))))
  (divide-to-one-equation rules))
)
;(cout 
; ((car (dtlog->ra '(((p X Y) (p X Z) (p Z Y))))) 
; '((#(1 2) #(2 4))) '(p))
;nl)
; -> '(#(1 4))

;(cout 
; ((car (dtlog->ra '(((anc X Y) (par X Y))))) 
;   '(() (#(b a) #(b g) #(a d) #(a e) #(d f) #(c h))) '(anc par))
; nl)
; -> '(#(1 2) #(1 4))


;  (((%anc X Y) (%anc X Z) (%par Z Y)) 
;  ((%anc X Y) (%par X Y)))
